> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/umbraco-cms/extend-your-project/server-side-extensions/api-documentation.md).

# API Documentation

A library of API Reference documentation is auto-generated from the comments within the Umbraco Source Code.

## C# API Documentation

C# API references for the Umbraco Core, Infrastructure, Extensions, and Web libraries.

### [Umbraco.Cms.Core](https://apidocs.umbraco.com/v17/csharp/api/Umbraco.Cms.Core.html)

### [Umbraco.Cms.Infrastructure](https://apidocs.umbraco.com/v17/csharp/api/Umbraco.Cms.Infrastructure.html)

### [Umbraco.Cms.Web](https://apidocs.umbraco.com/v17/csharp/api/Umbraco.Cms.Web.Common.html)

### [Umbraco.Extensions](https://apidocs.umbraco.com/v17/csharp/api/Umbraco.Extensions.html)

{% hint style="info" %}
Opens a documentation browser that is different from the documentation section you're viewing now.
{% endhint %}

## Backoffice UI Documentation

You can find all reference documentation for the Backoffice UI in the [UI Library](/umbraco-cms/extend-your-project/backoffice-extensions/ui-library.md) article.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.umbraco.com/umbraco-cms/extend-your-project/server-side-extensions/api-documentation.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
